## EDU.oswego.cs.dl.util.concurrent
Class VetoableChangeMulticaster

    java.lang.Object
      EDU.oswego.cs.dl.util.concurrent.VetoableChangeMulticaster

All Implemented Interfaces:
  java.io.Serializable

    public class VetoableChangeMulticaster

extends java.lang.Object
implements java.io.Serializable

This class is interoperable with java.beans.VetoableChangeSupport, but relies on a streamlined copy-on-write scheme similar to that used in CopyOnWriteArrayList. It also adheres to clarified semantics of add, remove, and fireVetoableChange operations.

Sample usage.

     class Thing {
       protected Color myColor = Color.red; // an example property
       protected boolean changePending; // track whether in midst of change

       // vetoable listeners:
       protected VetoableChangeMulticaster vetoers =
         new VetoableChangeMulticaster(this);

       // Possibly also some ordinary listeners:
       protected PropertyChangeMulticaster listeners =
         new PropertyChangeMulticaster(this);

       // registration methods, including:
       void addVetoer(VetoableChangeListener l) {
         // Use the `ifAbsent' version to avoid duplicate notifications
         vetoers.addVetoableChangeListenerIfAbsent(l);
       }

       public synchronized Color getColor() { // accessor
         return myColor;
       }

       // Simple transactional control for vetos

       public void setColor(int newColor) throws PropertyVetoException {
         Color oldColor = prepareSetColor(newColor);

         try {
           vetoers.fireVetoableChange("color", oldColor, newColor);
           commitColor(newColor);
           listeners.firePropertyChange("color", oldColor, newColor);
         }
         catch(PropertyVetoException ex) {
           abortSetColor();
           throw ex;
         }
       }

       // Called on entry to proposed vetoable change from setColor.
       // Throws exception if there is already another change in progress.
       // Returns current color
       synchronized int prepareSetColor(Color c) throws PropertyVetoException {
         // only support one transaction at a time
         if (changePending)
           throw new PropertyVetoException("Concurrent modification");
           // (Could alternatively wait out other transactions via
           // a wait/notify construction based on changePending.)

         // perhaps some other screenings, like:
         else if (c == null)
           throw new PropertyVetoException("Cannot change color to Null");
         else {
           changePending = true;
           return myColor;
         }
       }

       synchronized void commitColor(Color newColor) {
         myColor = newColor;
         changePending = false;
       }

       synchronized void abortSetColor() {
         changePending = false;
       }

     }

[ Introduction to this package. ]

See Also:
  Serialized Form

Field Summary
`protected java.util.HashMap` `children` HashMap for managing listeners for specific properties.
`protected java.beans.VetoableChangeListener[]` `listeners` The array of listeners.
`protected java.lang.Object` `source` The object to be provided as the "source" for any generated events.

Constructor Summary
`VetoableChangeMulticaster(java.lang.Object sourceBean)` Constructs a `VetoableChangeMulticaster` object.

Method Summary
`void` `addVetoableChangeListener(java.lang.String propertyName, java.beans.VetoableChangeListener listener)` Add a VetoableChangeListener for a specific property.
`void` `addVetoableChangeListener(java.beans.VetoableChangeListener listener)` Add a VetoableChangeListener to the listener list.
`void` `addVetoableChangeListenerIfAbsent(java.lang.String propertyName, java.beans.VetoableChangeListener listener)` Add a VetoableChangeListener for a specific property, if it is not already registered.
`void` `addVetoableChangeListenerIfAbsent(java.beans.VetoableChangeListener listener)` Add a PropertyChangeListener to the listener list if it is not already present.
`void` `fireVetoableChange(java.beans.PropertyChangeEvent evt)` Report a vetoable property update to any registered listeners.
`void` `fireVetoableChange(java.lang.String propertyName, boolean oldValue, boolean newValue)` Report a vetoable property update to any registered listeners.
`void` `fireVetoableChange(java.lang.String propertyName, int oldValue, int newValue)` Report a vetoable property update to any registered listeners.
`void` `fireVetoableChange(java.lang.String propertyName, java.lang.Object oldValue, java.lang.Object newValue)` Report a vetoable property update to any registered listeners.
`protected VetoableChangeMulticaster` `getChild(java.lang.String propertyName)` Return the child associated with property, or null if no such
`boolean` `hasListeners(java.lang.String propertyName)` Check if there are any listeners for a specific property.
`protected void` `multicast(java.beans.PropertyChangeEvent evt)` Helper method to relay evt to all listeners.
`void` `removeVetoableChangeListener(java.lang.String propertyName, java.beans.VetoableChangeListener listener)` Remove a VetoableChangeListener for a specific property.
`void` `removeVetoableChangeListener(java.beans.VetoableChangeListener listener)` Remove an occurrence of a VetoableChangeListener from the listener list.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### listeners

    protected transient java.beans.VetoableChangeListener[] listeners

  The array of listeners. Copied on each update

### source

    protected final java.lang.Object source

  The object to be provided as the "source" for any generated events.

### children

    protected java.util.HashMap children

  HashMap for managing listeners for specific properties. Maps property names to VetoableChangeMulticaster objects.

Constructor Detail

### VetoableChangeMulticaster

    public VetoableChangeMulticaster(java.lang.Object sourceBean)

  Constructs a `VetoableChangeMulticaster` object.

  Parameters:
    `sourceBean` - The bean to be given as the source for any events.
  Throws:
    `java.lang.NullPointerException` - if sourceBean is null

Method Detail

### getChild

    protected VetoableChangeMulticaster getChild(java.lang.String propertyName)

  Return the child associated with property, or null if no such

### addVetoableChangeListener

    public void addVetoableChangeListener(java.beans.VetoableChangeListener listener)

  Add a VetoableChangeListener to the listener list. The listener is registered for all properties. If the listener is added multiple times, it will receive multiple change notifications upon any fireVetoableChange.

  Parameters:
    `listener` - The VetoableChangeListener to be added

### addVetoableChangeListenerIfAbsent

    public void addVetoableChangeListenerIfAbsent(java.beans.VetoableChangeListener listener)

  Add a PropertyChangeListener to the listener list if it is not already present. The listener is registered for all properties. The operation maintains Set semantics: If the listener is already registered, the operation has no effect.

  Parameters:
    `listener` - The PropertyChangeListener to be added
  Throws:
    `java.lang.NullPointerException` - If listener is null

### removeVetoableChangeListener

    public void removeVetoableChangeListener(java.beans.VetoableChangeListener listener)

  Remove an occurrence of a VetoableChangeListener from the listener list. It removes at most one occurrence of the given listener. If the listener was added multiple times it must be removed mulitple times. This removes a VetoableChangeListener that was registered for all properties, and has no effect if registered for only one or more specified properties.

  Parameters:
    `listener` - The VetoableChangeListener to be removed

### addVetoableChangeListener

    public void addVetoableChangeListener(java.lang.String propertyName,
                                          java.beans.VetoableChangeListener listener)

  Add a VetoableChangeListener for a specific property. The listener will be invoked only when a call on fireVetoableChange names that specific property. However, if a listener is registered both for all properties and a specific property, it will receive multiple notifications upon changes to that property.

  Parameters:
    `propertyName` - The name of the property to listen on.
    `listener` - The VetoableChangeListener to be added
  Throws:
    `java.lang.NullPointerException` - If listener is null

### addVetoableChangeListenerIfAbsent

    public void addVetoableChangeListenerIfAbsent(java.lang.String propertyName,
                                                  java.beans.VetoableChangeListener listener)

  Add a VetoableChangeListener for a specific property, if it is not already registered. The listener will be invoked only when a call on fireVetoableChange names that specific property.

  Parameters:
    `propertyName` - The name of the property to listen on.
    `listener` - The VetoableChangeListener to be added
  Throws:
    `java.lang.NullPointerException` - If listener is null

### removeVetoableChangeListener

    public void removeVetoableChangeListener(java.lang.String propertyName,
                                             java.beans.VetoableChangeListener listener)

  Remove a VetoableChangeListener for a specific property. Affects only the given property. If the listener is also registered for all properties, then it will continue to be registered for them.

  Parameters:
    `propertyName` - The name of the property that was listened on.
    `listener` - The VetoableChangeListener to be removed

### multicast

    protected void multicast(java.beans.PropertyChangeEvent evt)
                      throws java.beans.PropertyVetoException

  Helper method to relay evt to all listeners. Called by all public fireVetoableChange methods.

  Throws:
    `java.beans.PropertyVetoException`

### fireVetoableChange

    public void fireVetoableChange(java.lang.String propertyName,
                                   java.lang.Object oldValue,
                                   java.lang.Object newValue)
                            throws java.beans.PropertyVetoException

  Report a vetoable property update to any registered listeners. Notifications are sent serially (although in no particular order) to the list of listeners, aborting if one throws PropertyVetoException. Upon this exception, fire a new event reverting this change to all listeners that have already been notified (ignoring any further vetos), suppress notifications to all other listeners, and then rethrow the PropertyVetoException.

  No event is fired if old and new are equal non-null.

  Parameters:
    `propertyName` - The programmatic name of the property that was changed.
    `oldValue` - The old value of the property.
    `newValue` - The new value of the property.
  Throws:
    `java.beans.PropertyVetoException` - if a recipient wishes the property change to be rolled back.

### fireVetoableChange

    public void fireVetoableChange(java.lang.String propertyName,
                                   int oldValue,
                                   int newValue)
                            throws java.beans.PropertyVetoException

  Report a vetoable property update to any registered listeners. Notifications are sent serially (although in no particular order) to the list of listeners, aborting if one throws PropertyVetoException. Upon this exception, fire a new event reverting this change to all listeners that have already been notified (ignoring any further vetos), suppress notifications to all other listeners, and then rethrow the PropertyVetoException.

  No event is fired if old and new are equal.

  This is merely a convenience wrapper around the more general fireVetoableChange method that takes Object values.

  Parameters:
    `propertyName` - The programmatic name of the property that was changed.
    `oldValue` - The old value of the property.
    `newValue` - The new value of the property.
  Throws:
    `java.beans.PropertyVetoException` - if the recipient wishes the property change to be rolled back.

### fireVetoableChange

    public void fireVetoableChange(java.lang.String propertyName,
                                   boolean oldValue,
                                   boolean newValue)
                            throws java.beans.PropertyVetoException

  Report a vetoable property update to any registered listeners. Notifications are sent serially (although in no particular order) to the list of listeners, aborting if one throws PropertyVetoException. Upon this exception, fire a new event reverting this change to all listeners that have already been notified (ignoring any further vetos), suppress notifications to all other listeners, and then rethrow the PropertyVetoException.

  No event is fired if old and new are equal.

  This is merely a convenience wrapper around the more general fireVetoableChange method that takes Object values.

  Parameters:
    `propertyName` - The programmatic name of the property that was changed.
    `oldValue` - The old value of the property.
    `newValue` - The new value of the property.
  Throws:
    `java.beans.PropertyVetoException` - if the recipient wishes the property change to be rolled back.

### fireVetoableChange

    public void fireVetoableChange(java.beans.PropertyChangeEvent evt)
                            throws java.beans.PropertyVetoException

  Report a vetoable property update to any registered listeners. Notifications are sent serially (although in no particular order) to the list of listeners, aborting if one throws PropertyVetoException. Upon this exception, fire a new event reverting this change to all listeners that have already been notified (ignoring any further vetos), suppress notifications to all other listeners, and then rethrow the PropertyVetoException.

  No event is fired if old and new are equal and non-null. equal and non-null.

  Parameters:
    `evt` - The PropertyChangeEvent object.
  Throws:
    `java.beans.PropertyVetoException` - if the recipient wishes the property change to be rolled back.

### hasListeners

    public boolean hasListeners(java.lang.String propertyName)

  Check if there are any listeners for a specific property. If propertyName is null, return whether there are any listeners at all.

  Parameters:
    `propertyName` - the property name.
  Returns:
    true if there are one or more listeners for the given property